Registri_Pasien_Multi_Drug/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('pasien/', include('pasien.urls', namespace="pasien")),
    path('', include('dashboard.urls', namespace="dashboard")),
]

pasien/urls.py
from django.urls import path
from . import views

app_name = 'pasien'

urlpatterns = [

    path('', views.list_view, name='index'),
    path('forms/', views.forms, name='form_pasien'),
    path('delete/<int:nomor>', views.delete_pasien, name='delete_pasien'),
    path('edit/<int:nomor>', views.edit_pasien, name='edit_pasien'),
    # path('import/', views.import_file, name='import'),
    path('export/', views.download, name='export'),
    path('login/', views.loginAdmin, name='login'),
    path('logout/', views.logoutAdmin, name='logout'),
]

pasien/models.py
from django.db import models

# Create your models here.


class Pasien(models.Model):

    ADA_TIDAK_CHOICES = (("ada", "ada"), ("tidak ada", "tidak ada"))

    JENIS_KELAMIN_CHOICES = (("Laki-laki", "Laki-laki"),
                             ("Perempuan", "Perempuan"))

    POSITIF_CHOICES = (("Positif", "Positif"),
                        ("Negatif", "Negatif"))        



    ### DATA PASIEN ###
    no = models.AutoField(primary_key=True)

    nama = models.CharField(max_length=255, blank=True, null=True)

    no_medrek = models.CharField(max_length=255, blank=True, null=True)

    no_hp = models.CharField(max_length=255, blank=True, null=True)

    tanggal_lahir = models.DateField(blank=True, null=True)

    jenis_kelamin = models.CharField(max_length=255,
                                    blank=True,
                                    null=True,
                                    choices=JENIS_KELAMIN_CHOICES)

    tahun_kasus = models.PositiveIntegerField(blank=True, null=True)

    alamat = models.TextField(max_length=255, blank=True, null=True)
    
    tanggal_mrs = models.DateField(blank=True, null=True)

    tanggal_mulai_oat = models.DateField(blank=True, null=True)

    jumlah_pengobatan_tbc_sebelumnya = models.CharField(max_length=255, blank=True, null=True)

    jenis_resistensi = models.CharField(max_length=255, blank=True, null=True)

    jenis_tbc = models.CharField(max_length=255, blank=True, null=True)


    ### Anamnesis ###

    batuk = models.CharField(max_length=255, blank=True, null=True, choices=ADA_TIDAK_CHOICES)

    dahak = models.CharField(max_length=255, blank=True, null=True, choices=ADA_TIDAK_CHOICES)

    demam = models.CharField(max_length=255, blank=True, null=True, choices=ADA_TIDAK_CHOICES)

    sesak = models.CharField(max_length=255, blank=True, null=True, choices=ADA_TIDAK_CHOICES)

    keringat_malam = models.CharField(max_length=255, blank=True, null=True, choices=ADA_TIDAK_CHOICES)

    penurunan_bb = models.CharField(max_length=255, blank=True, null=True, choices=ADA_TIDAK_CHOICES)

    hambatan_pertumbuhan = models.CharField(max_length=255, blank=True, null=True, choices=ADA_TIDAK_CHOICES)

    penurunan_nafsu_makan = models.CharField(max_length=255, blank=True, null=True, choices=ADA_TIDAK_CHOICES)

    ### Pemeriksaan Fisisk ###

    bb = models.CharField(max_length=255, blank=True,null=True)

    tb = models.CharField(max_length=255, blank=True,null=True)

    rr = models.CharField(max_length=255, blank=True,null=True)

    suhu = models.CharField(max_length=255, blank=True, null=True)

    kgb = models.CharField(max_length=255, blank=True, null=True)

    pulmo = models.CharField(max_length=255, blank=True, null=True)

    ### Penunjang ### 

    bta1 = models.CharField(max_length=255, blank=True, null=True, choices=POSITIF_CHOICES)

    bta2 = models.CharField(max_length=255, blank=True, null=True, choices=POSITIF_CHOICES)

    bta3 = models.CharField(max_length=255, blank=True, null=True, choices=POSITIF_CHOICES)

    gene_xpert = models.CharField(max_length=255, blank=True, null=True)

    kultur_mtb = models.CharField(max_length=255, blank=True, null=True)

    drug_sensitivity_test_oat = models.CharField(max_length=255, blank=True, null=True)

    foto_toraks = models.CharField(max_length=255, blank=True, null=True)

    tes_ppd = models.CharField(max_length=255, blank=True, null=True)

    lpa = models.CharField(max_length=255, blank=True, null=True)

    ### Terapi ###

    terapi = models.CharField(max_length=255, blank=True, null=True) 

    ### Sumber Kontak Dewasa ### 

    nama_skd = models.CharField(max_length=255, blank=True, null=True)
    
    hubungan = models.CharField(max_length=255, blank=True, null=True)

    tanggal_lahir_skd = models.DateField(blank=True, null=True)

    jenis_kasus_tb = models.CharField(max_length=255, blank=True, null=True)

    ### Tempat ambil obat ### 

    tempat_ambil_obat = models.CharField(max_length=255, blank=True, null=True)

    ### Follow Up ###

    follow_up_1 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_2 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_3 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_4 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_5 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_6 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_7 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_8 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_9 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_10 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_11 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_12 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_13 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_14 = models.TextField(max_length=255, blank=True, null=True)
    
    follow_up_15 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_16 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_17 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_18 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_19 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_20 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_21 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_22 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_23 = models.TextField(max_length=255, blank=True, null=True)

    follow_up_24 = models.TextField(max_length=255, blank=True, null=True)

    #### Output ###

    output = models.CharField(max_length=255, blank=True, null=True)


    def __str__(self):
        return self.nama

    def get_fields(self):
        return [(field.name, field.value_to_string(self)) for field in Pasien._meta.fields]

    def get_header():
        return [(field.name) for field in Pasien._meta.fields]

    def get_all_value(self):
        return [field.value_from_object(self) for field in Pasien._meta.fields]

    def dict_value(self): 
        return {field.name : field.value_from_object(self) for field in Pasien._meta.fields}

pasien/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.http import HttpResponseNotAllowed, HttpResponse
from django.urls import reverse_lazy
from django.contrib.auth import authenticate, login, logout
from django.contrib import messages
from django.contrib.auth.decorators import login_required

from .forms import PasienForm, ExcelUploadForm
from .models import Pasien

import datetime
from openpyxl import load_workbook, Workbook
from openpyxl.utils import get_column_letter
from openpyxl.writer.excel import save_virtual_workbook
from openpyxl.styles import Border, Side, Alignment, PatternFill
import copy
# Pasien

def loginAdmin(request):
    if request.method == 'POST':
        username = request.POST.get('username')
        password = request.POST.get('password')

        user = authenticate(request, username=username, password=password)

        if user is not None:
            login(request, user)
            return redirect('dashboard:index')
        
        else:
            messages.info(request, 'Username atau Password salah')
        
        return redirect('pasien:login')

    return render(request, 'login.html')

@login_required(login_url='pasien:login')
def logoutAdmin(request):
    logout(request)

    return redirect('pasien:login')

@login_required(login_url='pasien:login')
def list_view(request):
    if request.method == "GET":
        pasien = Pasien.objects.all()
        header = Pasien.get_header()

        context = {'pasien': pasien, 'header': header,
                   "excel_upload_form": ExcelUploadForm()}
        return render(request, 'list-pasien.html', context)

    if request.method == "POST":
        context = {"excel_upload_form": ExcelUploadForm()}
        return post_import_excel_page(request, context)

    return HttpResponseNotAllowed(["GET", "POST"])

@login_required(login_url='pasien:login')
def forms(request):
    pasien_form = PasienForm(request.POST or None)
    if request.method == 'POST':
        if pasien_form.is_valid():
            pasien_form.save()

        return redirect('pasien:index')

    context = {
        'title': 'Formulir Pasien',
        'pasien_form': pasien_form
    }

    return render(request, 'forms-pasien.html', context)

@login_required(login_url='pasien:login')
def delete_pasien(request, nomor):
    if request.method == 'POST':
        pasien = get_object_or_404(Pasien, no=nomor)
        pasien.delete()

        return redirect('pasien:index')
    return HttpResponseNotAllowed(["POST"])

def edit_pasien(request, nomor):
    instance = Pasien.objects.get(no=nomor)
    data = instance.dict_value()
    pasien_form = PasienForm(request.POST or None, initial=data, instance=instance)

    context = {"pasien_form": pasien_form}

    if request.method == "POST":
        if pasien_form.is_valid():
            pasien_form.save()

        return redirect('pasien:index')

    if request.method == "GET":
        return render(request, 'forms-pasien.html', context)
        
    return HttpResponseNotAllowed(["GET", "POST"])

def import_file(request):
    response = {"excel_upload_form": ExcelUploadForm()}
    if request.method == "GET":
        return get_import_excel_page(request, response)
    if request.method == "POST":
        return post_import_excel_page(request, response)
    return HttpResponseNotAllowed(["GET", "POST"])

def get_import_excel_page(request, response):
    return render(request, "import.html", response)

def post_import_excel_page(request, response):
    Pasien.objects.all().delete()
    form = ExcelUploadForm(request.POST, request.FILES)
    if form.is_valid():
        workbook = load_workbook(request.FILES["excel_file"])
        sheet = workbook.active

        for row in sheet.iter_rows(min_row=3, values_only=True, max_col=67):
            row = list(row)
            row[4] = check(row[4])
            row[8] = check(row[8])
            row[9] = check(row[9])
            row[39] = check(row[39])

            for i in range(67):
                if row[i] == '' or row[i] == ' ' :
                    row[i] = None

            pasien = Pasien(*row)

            pasien.save()

    return redirect(reverse_lazy('pasien:index'))

def check(x):
    if (not isinstance(x, datetime.date)):
        return None
    return x


def export_to_excel():
    wb = Workbook()

    ws1 = wb.active
    ws1.title = "Pasien"

    list_title1 = ["No", "Nama", "No MedRek", "No HP", "Tgl Lahir", "Jenis Kelamin", "Tahun Kasus", "Alamat", "Tanggal MRS", "Tanggal mulai OAT", "Jumlah pengobatan TBC sebelumnya", "Jenis Resistensi", "Jenis TBC", ]
    list_title2 = []

    for i in range (0, 8):
        if (i == 0):
            list_title1.append("Anamnesis")
        else:
            list_title1.append("blank")

    for i in range(0,6):
        if(i == 0):
            list_title1.append("Pemeriksaan fisik")
        else:
            list_title1.append("blank")

    for i in range(0,9):
        if(i == 0):
            list_title1.append("Penunjang")
        else:
            list_title1.append("blank")

    list_title1 = list_title1 + ["Terapi"]

    for i in range(0,4):
        if(i == 0):
            list_title1.append("Sumber kontak dewasa")
        else:
            list_title1.append("blank")

    list_title1 = list_title1 + ["Tempat ambil obat"]

    for i in range(0,24):
        if(i == 0):
            list_title1.append("Follow up")
        else:
            list_title1.append("blank")

    list_title1 = list_title1 + ["Output"]

    # Append head to file
    ws1.append(list_title1)

    # head2 file
    for i in range(0,13):
        list_title2.append("blank")
    list_title2 = list_title2 + ["Batuk", "Dahak", "Demam", "Sesak", "Keringat Malam", "Penurunan BB", "Hambatan Pertumbuhan", "Penurunan Nafsu Makan"]
    list_title2 = list_title2 + ["BB", "TB", "RR", "Suhu", "KGB", "Pulmo"]
    list_title2 = list_title2 + ["BTA 1", "BTA 2", "BTA 3", "Gene Xpert", "Kultur MTB", "Drug", "Foto Toraks", "Tes PPD", "LPA"]
    list_title2 = list_title2 + ["blank", "Nama", "Hubungan", "Tgl lahir", "Jenis kasus TB"]
    list_title2 = list_title2 + ["blank"]

    # untuk follow up
    for i in range(0,24):
        list_title2 = list_title2 + [i + 1]
    ws1.append(list_title2)


    # masukin data
    all_pasien = Pasien.objects.all().order_by("no")
    for pasien in all_pasien:
        ws1.append(pasien.get_all_value())


    # dimension size
    for col in range(2, 8):
        ws1.column_dimensions[get_column_letter(col)].width = 25

    # size Alamat
    ws1.column_dimensions[get_column_letter(8)].width = 60

    # size Tanggal MRS - Jenis TBC
    ws1.column_dimensions[get_column_letter(9)].width = 20
    ws1.column_dimensions[get_column_letter(10)].width = 20
    ws1.column_dimensions[get_column_letter(11)].width = 35
    ws1.column_dimensions[get_column_letter(12)].width = 20
    ws1.column_dimensions[get_column_letter(13)].width = 20

    # col size Anamnesis (Batuk - Penurunan)
    for col in range(14, 22):
        ws1.column_dimensions[get_column_letter(col)].width = 20

    # col size Pemeriksaan fisik (BB - Pulmo)
    for col in range(22, 26):
        ws1.column_dimensions[get_column_letter(col)].width = 20
    for col in range(26, 28):
        ws1.column_dimensions[get_column_letter(col)].width = 40

    # col size Penunjang (BTA1 - LPA)
    for col in range(28, 31):
        ws1.column_dimensions[get_column_letter(col)].width = 20
    for col in range(31, 37):
        ws1.column_dimensions[get_column_letter(col)].width = 35
        
    # col size Terapi
    ws1.column_dimensions[get_column_letter(37)].width = 60

    # col size Sumber kontak dewasa + Tempat ambil obat
    for col in range(38, 43):
        ws1.column_dimensions[get_column_letter(col)].width = 35

    # col size   Follow Up (1 - 24) + output
    for col in range(43, 67):
        ws1.column_dimensions[get_column_letter(col)].width = 35
    
    ws1.column_dimensions[get_column_letter(67)].width = 30                                                                          

    # row
    for row in range(3,100):
        ws1.row_dimensions[row].height = 120

    ws1.row_dimensions[1].height = 35
    ws1.row_dimensions[2].height = 30

    # Ini buat styling
    for row in range(1,len(all_pasien)+3):
        for col in range(1,68):
            ws1["{}{}".format(get_column_letter(col), row)].border = Border(left=Side(border_style="thin",
                            color='00000000'),
                    right=Side(border_style="thin",
                                color='00000000'),
                    top=Side(border_style="thin",
                            color='00000000'),
                    bottom=Side(border_style="thin",
                                color='00000000'),
                    )

            ws1["{}{}".format(get_column_letter(col), row)].alignment = Alignment(horizontal="center", vertical="center")


            if(ws1.cell(row, 67).value != None) :
                if( (ws1.cell(row, 67).value).lower() == "sembuh"):
                    ws1["{}{}".format(get_column_letter(col), row)].fill = PatternFill("solid", fgColor="c5e0b3")
                
                if( "masih berobat" in (ws1.cell(row, 67).value).lower() ):
                    ws1["{}{}".format(get_column_letter(col), row)].fill = PatternFill("solid", fgColor="ffebf2")

                if( "meninggal" in (ws1.cell(row, 67).value).lower()):
                    ws1["{}{}".format(get_column_letter(col), row)].fill = PatternFill("solid", fgColor="ff0000")
                
            if(col == 7):
                ws1["{}{}".format(get_column_letter(col), row)].fill = PatternFill("solid", fgColor="fff600")

            if(row == 1 or row == 2):
                ws1["{}{}".format(get_column_letter(col), row)].fill = PatternFill("solid", fgColor="00b0f0")

    for row in ws1.iter_rows():
        for cell in row:      
            alignment = copy.copy(cell.alignment)

pasien/templates/forms-pasien.html
{% extends 'base.html' %} {% load static %} {% block meta %}
<title>Register Pasien</title>
{% endblock meta %} {% block content %}
<div class="container">
	<form method="POST">
		{% csrf_token %}
		{% for field in pasien_form %}

			{% if field.label == "Nama" %}
			<h3 class="mb-3"><strong>Data Pasien</strong></h3>
			<hr style="width:10%;"/>

			{% elif field.label == "Batuk" %}
			<h3 class="mb-3 mt-5"><strong>Anamnesis</strong></h3>
			<hr style="width:10%;"/>

			{% elif field.label == "BB" %}
			<h3 class="mb-3 mt-5"><strong>Pemeriksaan Fisik</strong></h3>
			<hr style="width:10%;"/>

			{% elif field.label == "BTA 1" %}
			<h3 class="mb-3 mt-5"><strong>Penunjang</strong></h3>
			<hr style="width:10%;"/>

			{% elif field.label == "Terapi" %}
			<h3 class="mb-3 mt-5"><strong>Terapi</strong></h3>
			<hr style="width:10%;"/>

			{% elif field.label == "Nama sumber" %}
			<h3 class="mb-3 mt-5"><strong>Sumber kontak dewasa</strong></h3>
			<hr style="width:10%;"/>

			{% elif field.label == "Tempat ambil obat" %}
			<h3 class="mb-3 mt-5"><strong>Tempat ambil obat</strong></h3>
			<hr style="width:10%;"/>
			
			{% elif field.label == "1" %}
			<h3 class="mb-3 mt-5"><strong>Follow up</strong></h3>
			<hr style="width:10%;"/>

			{% elif field.label == "Output" %}
			<h3 class="mb-3 mt-5"><strong>Output</strong></h3>
			<hr style="width:10%;"/>

			{% endif %}

			<div class="mb-3">
				<label class="form-label">{{ field.label }}</label>
				{{ field }}
  			</div>

		{% endfor %}
		<button type="submit" class="btn btn-primary mb-5">Register</button>
	</form>
</div>

{% endblock content %}

pasien/templates/import.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
{% endblock meta %}

{% block content %}

<div class="container">
	<div class="form-header">
		<h1>Tambahkan Pasien Baru</h1>
	</div>
	
	<form
		id="form"
		class="form-base"
		method="POST"
		enctype="multipart/form-data"
		action=""
	>
		{% csrf_token %}
		<div class="form-fields">
			{% for field in excel_upload_form %}
			<div class="field-wrapper">
				<div class="field-input">{{ field.label_tag }} {{ field }}</div>
				<div class="field-error">{{ field.errors }}</div>
				{% if field.help_text %}
				<p class="help">{{ field.help_text|safe }}</p>
				{% endif %}
			</div>
			{% endfor %}
		</div>
		<button type="submit" class="button btn btn-primary form-submit-button">
			Send
		</button>
	</form>
	</form>
</div>

{% endblock content %}

pasien/templates/list-pasien.html
{% extends 'base.html' %} {% load static %} {% block meta %}
<title>List Pasien</title>
{% endblock meta %} {% block content %}

<div class="container d-flex flex-row justify-content-center">
	<!-- Button trigger modal -->
	<button type="button" class="btn btn-primary me-3" data-bs-toggle="modal" data-bs-target="#exampleModal">
		Import dari Excel
	</button>
	
	<!-- Modal -->
	<div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
		<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
			<h5 class="modal-title" id="exampleModalLabel">Masukan File Excel</h5>
			<button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
			</div>

			<div class="modal-body">
				<form
				id="form"
				class="form-base"
				method="POST"
				enctype="multipart/form-data"
				action=""
			>
				{% csrf_token %}
				<div class="form-fields">
					{% for field in excel_upload_form %}
					<div class="field-wrapper">
						<div class="field-input">{{ field.label_tag }} {{ field }}</div>
						<div class="field-error">{{ field.errors }}</div>
						{% if field.help_text %}
						<p class="help">{{ field.help_text|safe }}</p>
						{% endif %}
					</div>
					{% endfor %}
				</div>

				<button type="button" class="btn btn-secondary mt-4" data-bs-dismiss="modal">
					Batal
				</button>
				<button type="submit" class="button btn btn-primary form-submit-button mt-4">
					Import
				</button>
			</form>
			</div>
		</div>
		</div>
	</div>

	<a type="button" class="btn btn-primary ms-3" href="{% url 'pasien:export' %}">Export ke Excel</a>
</div>

<div class="container mt-4" style="overflow-x: auto">	
	<table class="table table-light table-bordered table-striped rounded" id="myTable">
		<thead>
			<tr>
				<th>Update/Hapus</th>

				<!-- ["No medrek",	"Nama",	"Usia", "Jenis Kelamin","Tempat Lahir","Tanggal Lahir","Alamat","Status Pendidikan Pasien","Socioeconomi","Asuransi","Status Pendidikan Ayah","Status Pendidikan Ibu", "Lama Perawatan","BB/U", "PB/U", "LLA/U", "BB/PB", "Status Gizi", "Gejala Utama", "Gejala Penyerta", "Kontak TB", "PDD Test", "BTA", "TCM Kategori", "Hemoglobin", "Hematokrit", "Eritosit", "Trombosit", "Leukosit", "CRP", "Kultur Darah", "Procalcitonin", "Albumin", "ALT", "AST", "Bilirubin Total", "Bilirubin Direk", "Bilirubin Indirek","Jumlah Sel", "Protein", "PMN","MN","BTA","Gula","Gram","Kultur", "Hasil Foto Thorak", "Genexpert (TCM)","EKG","Hasil CT Scan", "Hasil Pemeriksaan Uji Kepekatan Obat", "Komplikasi", "Terapi OAT", "Obat yang Digunakan", "Keadaan Pasien Pasca Terapi", "ADIH", "Riwayat Pengobatan", "Diagnosis"] -->
				{% for name in header %}
				<th>{{ name }}</th>
				{% endfor %}
			</tr>
		</thead>

		<tbody>
			{% for pasien in pasien %}

			<tr>
				<td>
					<form
						method="POST"
						action="{% url 'pasien:delete_pasien' pasien.no %}"
					>
						<a
							class="btn btn-sm btn-primary"
							href="{% url 'pasien:edit_pasien' pasien.no %}"
							>Update</a
						>
						{% csrf_token %}
						<button
							name="submit"
							type="submit"
							class="btn btn-sm btn-danger mt-2"
							onclick="return confirm('Anda yakin ingin menghapus data pasien dengan nomor medrek {{pasien.pk}}?');"
						>
							Hapus
						</button>
					</form>
				</td>

				{% for name, value in pasien.get_fields %}
				<td>{{ value }}</td>
				{% endfor %}
			</tr>

			{% endfor %}
		</tbody>
	</table>
</div>
{% endblock content %} 

{% block script %}
<script>
	var table, rows, switching, i, x, y, shouldSwitch;
	table = document.getElementById("myTable");
	switching = true;
	/*Make a loop that will continue until
    no switching has been done:*/
	while (switching) {
		//start by saying: no switching is done:
		switching = false;
		rows = table.rows;
		/*Loop through all table rows (except the
        first, which contains table headers):*/
		for (i = 1; i < rows.length - 1; i++) {
			//start by saying there should be no switching:
			shouldSwitch = false;
			/*Get the two elements you want to compare,
            one from current row and one from the next:*/
			x = rows[i].getElementsByTagName("TD")[1];
			y = rows[i + 1].getElementsByTagName("TD")[1];
			//check if the two rows should switch place:
			if (Number(x.innerHTML) > Number(y.innerHTML)) {
				//if so, mark as a switch and break the loop:
				shouldSwitch = true;
				break;
			}
		}
		if (shouldSwitch) {
			/*If a switch has been marked, make the switch
        and mark that a switch has been done:*/
			rows[i].parentNode.insertBefore(rows[i + 1], rows[i]);
			switching = true;
		}
	}
</script>
{% endblock script %}

pasien/templates/login.html
{% extends 'base.html' %} {% load static %} {% block meta %}
<title>Register Pasien</title>
{% endblock meta %} {% block content %}
<div class="container">
<h3 class="display-7 text-center mt-3 mb-3">Login Admin</h3>

<form method="POST" action=''>
    {% csrf_token %}

    <p>Username: <input type="text" name="username"></p>
    <p>Password: <input type="password" name="password"></p>

    <button type="submit" class="btn btn-primary mb-3">Masuk</button>

    {% for message in messages %}
        {% if message.tags %}
            <p class="{{ message.tags }}">{{ message }}</p>
        {% endif %}
    {% endfor %}
</form>
</div>

{% endblock content %}